%global with_grizzly 1
Name:          jersey
Version:       1.18.3
Release:       1%{?dist}
Summary:       JAX-RS (JSR 311) production quality Reference Implementation
# One file in jersey-core/ is under ASL 2.0 license
License:       (CDDL or GPLv2 with exceptions) and ASL 2.0
URL:           http://jersey.java.net/
Source0:       https://github.com/jersey/%{name}-1.x/archive/%{version}.tar.gz
Source1:       http://www.apache.org/licenses/LICENSE-2.0.txt
# remove org.aspectj aspectjrt
# remove testng classifier jdk15
# change javax.servlet servlet-api 2.5 with org.jboss.spec.javax.servlet jboss-servlet-api_3.0_spec
# change spring25-release-version [2.5.2,3) to 3
Patch0:        %{name}-1.15-contribs-spring-pom.patch
# Fix for rhbz#1019234
Patch1:        %{name}-1.17.1-remove-tools-scope-system.patch

Patch2:        %{name}-1.18.3-grizzly23.patch
Patch3:        %{name}-1.18.3-system-asm.patch

BuildRequires: ant
BuildRequires: ant-testutil
BuildRequires: eclipselink
BuildRequires: felix-osgi-core
BuildRequires: geronimo-annotation >= 1.0-7
BuildRequires: geronimo-jpa
BuildRequires: glassfish-fastinfoset
BuildRequires: glassfish-jaxb
BuildRequires: glassfish-jaxb-api
BuildRequires: grizzly
BuildRequires: jackson
BuildRequires: javamail
BuildRequires: jboss-ejb-3.1-api
BuildRequires: jboss-el-2.2-api
BuildRequires: jboss-jsp-2.2-api
BuildRequires: jboss-servlet-3.0-api
BuildRequires: jdom
BuildRequires: jettison
BuildRequires: jsr-311
%if %{?fedora} >= 21
BuildRequires: objectweb-asm3
%else
BuildRequires: objectweb-asm
%endif
BuildRequires: rome >= 0.9-11
BuildRequires: tomcat-lib
BuildRequires: weld-core
BuildRequires: weld-parent

# tests deps
BuildRequires: apache-commons-codec
BuildRequires: apache-commons-io
BuildRequires: aspectjweaver
BuildRequires: cglib
BuildRequires: cobertura
BuildRequires: hamcrest
BuildRequires: junit
BuildRequires: testng
BuildRequires: tomcat-lib

# contrib
BuildRequires: freemarker
BuildRequires: guice
BuildRequires: guice-extensions
BuildRequires: guice-servlet
BuildRequires: httpcomponents-client
BuildRequires: jakarta-commons-httpclient
BuildRequires: mimepull
#BuildRequires: simple >= 5.0.4 < 6.0
BuildRequires: springframework
BuildRequires: springframework-aop
BuildRequires: springframework-beans
BuildRequires: springframework-context
BuildRequires: springframework-web
BuildRequires: xerces-j2
# jersey maven-wald-plugin deps
BuildRequires: mvn(org.apache.maven:maven-artifact)
BuildRequires: mvn(org.apache.maven:maven-plugin-api)


BuildRequires: geronimo-parent-poms

#BuildRequires: buildnumber-maven-plugin
BuildRequires: maven-local
BuildRequires: maven-enforcer-plugin
BuildRequires: maven-istack-commons-plugin
BuildRequires: maven-jaxb2-plugin
BuildRequires: maven-plugin-build-helper
BuildRequires: maven-plugin-bundle
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-source-plugin
BuildRequires: maven-surefire-provider-junit
BuildRequires: maven-surefire-provider-testng

BuildArch:     noarch

%description
Jersey is the open source JAX-RS (JSR 311)
production quality Reference Implementation
for building RESTful Web services.

%package test-framework
Summary:       Jersey Test Framework

%description test-framework
%{summary}.

%package contribs
Summary:       Contributions to Jersey

%description contribs
Projects that provide additional functionality to jersey,
like integration with other projects/frameworks.

%package -n maven-wadl-plugin
Summary:       WADL Maven Mojo

%description -n maven-wadl-plugin
A maven plugin that generates a wadl file
from resource classes and more stuff.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-1.x-%{version}
find . -name "*.jar" -print -delete
find . -name "*.class" -print -delete

%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p1

cp -p %{SOURCE1} .
sed -i 's/\r//' LICENSE-2.0.txt

# unavailable deps
%pom_disable_module archetypes
%pom_disable_module archive
%pom_disable_module experimental
%pom_disable_module glassfish
%pom_disable_module jersey-bundle
%pom_disable_module jersey-documentation
%pom_disable_module jersey-grizzly
%pom_disable_module jersey-tests
%pom_disable_module osgi
%pom_disable_module ri
%pom_disable_module samples
%pom_disable_module tests

%pom_disable_module jersey-test-framework-grizzly jersey-test-framework
%pom_disable_module jersey-test-framework-embedded-glassfish jersey-test-framework
%pom_disable_module bill-burke-book contribs
%pom_disable_module jersey-atom-abdera contribs
%pom_disable_module jersey-non-blocking-client contribs
%pom_disable_module oauth-tests contribs/jersey-oauth
%pom_disable_module scala contribs
%pom_disable_module jersey-simple-server contribs

%pom_remove_plugin :maven-javadoc-plugin
%pom_remove_plugin :maven-source-plugin

# unavailable test deps
%pom_remove_dep com.sun.net.httpserver:http jersey-client

# disable embedded jsr-311 copy
%pom_remove_plugin :maven-dependency-plugin jersey-core

%pom_remove_plugin :maven-surefire-plugin jersey-core
%pom_remove_plugin :maven-surefire-plugin jersey-server

sed -i "s|<groupId>com.sun.tools.xjc.maven2|<groupId>org.jvnet.jaxb2.maven2|" jersey-server/pom.xml
# different jaxb-impl/runtime apis
%if %{?fedora} >= 21
sed -i "s|<artifactId>maven-jaxb-plugin|<artifactId>maven-jaxb22-plugin|" jersey-server/pom.xml
%else
sed -i "s|<artifactId>maven-jaxb-plugin|<artifactId>maven-jaxb21-plugin|" jersey-server/pom.xml
%endif

for p in jersey-atom jersey-client jersey-core jersey-fastinfoset \
 jersey-grizzly2 jersey-grizzly2-servlet jersey-json jersey-server \
 jersey-server-linking jersey-servlet jersey-test-framework/jersey-test-framework-core \
 jersey-test-framework/jersey-test-framework-external jersey-test-framework/jersey-test-framework-grizzly2 \
 jersey-test-framework/jersey-test-framework-http jersey-test-framework/jersey-test-framework-inmemory \
 contribs/ant-wadl-task contribs/jersey-apache-client contribs/jersey-apache-client4 contribs/jersey-freemarker \
 contribs/jersey-guice contribs/jersey-moxy contribs/jersey-multipart contribs/jersey-oauth/oauth-client \
 contribs/jersey-oauth/oauth-server contribs/jersey-oauth/oauth-signature contribs/jersey-wadl-json-schema \
 contribs/maven-wadl-plugin contribs/spring contribs/wadl-resourcedoc-doclet; do
%pom_remove_plugin :maven-source-plugin ${p}
done

%pom_remove_plugin :maven-dependency-plugin contribs/maven-wadl-plugin

# fix aId for new istack-commons maven plugin
sed -i "s|<artifactId>maven-istack-commons-plugin|<artifactId>istack-commons-maven-plugin|" pom.xml **/pom.xml

%pom_remove_dep org.osgi:osgi_R4_core jersey-server
%pom_add_dep org.apache.felix:org.osgi.core::provided jersey-server

%pom_remove_dep org.osgi:osgi_R4_core jersey-servlet
%pom_add_dep org.apache.felix:org.osgi.core::provided jersey-servlet
%pom_remove_dep ant:ant jersey-servlet
%pom_add_dep org.apache.ant:ant::provided jersey-servlet
%pom_remove_dep org.glassfish:javax.ejb jersey-servlet
%pom_add_dep org.jboss.spec.javax.ejb:jboss-ejb-api_3.1_spec::provided jersey-servlet
%pom_remove_dep javax.servlet:javax.servlet-api jersey-servlet
%pom_add_dep org.jboss.spec.javax.servlet:jboss-servlet-api_3.0_spec::provided jersey-servlet
%pom_remove_dep javax.servlet:jsp-api jersey-servlet
%pom_add_dep org.jboss.spec.javax.servlet.jsp:jboss-jsp-api_2.2_spec::provided jersey-servlet
%pom_remove_dep org.jboss.weld:weld-osgi-bundle jersey-servlet
%pom_add_dep org.jboss.weld:weld-core::provided jersey-servlet

%pom_remove_dep org.osgi:osgi_R4_core jersey-client
%pom_add_dep org.apache.felix:org.osgi.core::provided jersey-client
%pom_remove_dep org.glassfish.web:el-impl jersey-server-linking
%pom_add_dep org.apache.tomcat:tomcat-jasper-el jersey-server-linking

# [ERROR] 
# Artifact Ids of the format maven-___-plugin are reserved for 
# plugins in the Group Id org.apache.maven.plugins
# Please change your artifactId to the format ___-maven-plugin
# In the future this error will break the build.
sed -i 's|<artifactId>maven-wadl-plugin</artifactId>|<artifactId>wadl-maven-plugin</artifactId>|' \
  contribs/maven-wadl-plugin/pom.xml

# [ERROR] com.sun.jersey.wadl.GenerateWadlMojo#_wadlFile:
# [ERROR] Failed to execute goal org.apache.maven.plugins:maven-plugin-plugin:3.1:descriptor
# (default-descriptor) on project maven-wadl-plugin: Error extracting plugin descriptor:
# 'com.sun.jersey.wadl.GenerateWadlMojo#_wadlFile: cannot use both @parameter expression and property'
sed -i 's|property="wadlFile" expression="${project.build.directory}/application.wadl"|expression="${project.build.directory}/application.wadl"|' \
  contribs/maven-wadl-plugin/src/main/java/com/sun/jersey/wadl/GenerateWadlMojo.java

sed -i "s|<artifactId>apache-maven|<artifactId>maven-compat|" contribs/maven-wadl-plugin/pom.xml

# these test fails ( NOTE grizzly use servlet 3.1 apis, instead, jersey use servlet 3.0.1 apis )
rm -r contribs/jersey-apache-client/src/test/java/com/sun/jersey/client/apache/impl \
 jersey-test-framework/jersey-test-framework-grizzly2/src/test/java/com/sun/jersey/test/framework/impl/container/grizzlyweb2 \
 contribs/jersey-guice/src/test/java/com/sun/jersey/guice

# disable spring contribs tests. fails for various reasons
sed -i 's,<skip>${maven.test.skip}</skip>,<skip>true</skip>,' contribs/spring/pom.xml

%pom_add_dep commons-codec:commons-codec::test contribs/jersey-apache-client
%pom_add_dep commons-codec:commons-codec::test contribs/jersey-multipart

%pom_remove_dep javax.servlet:servlet-api contribs/jersey-guice
%pom_add_dep org.jboss.spec.javax.servlet:jboss-servlet-api_3.0_spec:any:provided contribs/jersey-guice

sed -i "s|org.eclipse.persistence.moxy|eclipselink|" pom.xml jersey-json/pom.xml contribs/jersey-moxy/pom.xml

# disable embedded jsr-311 copy
sed -i "s|<Export-Package>javax.ws.rs.*;-split-package:=merge-first,com.sun.jersey|<Export-Package>com.sun.jersey|" \
 jersey-core/pom.xml
sed -i "s|<Import-Package>!javax.ws.rs.*,javax.mail|<Import-Package>javax.ws.rs.*,javax.mail|" \
 jersey-core/pom.xml

sed -i "s|unpackBundle>true|unpackBundle>false|" pom.xml **/pom.xml
 
for p in jersey-atom jersey-client jersey-fastinfoset jersey-json jersey-server contribs/jersey-moxy ;do
%pom_add_dep javax.ws.rs:jsr311-api ${p}
done
for p in contribs/jersey-oauth/oauth-signature ;do
%pom_add_dep javax.ws.rs:jsr311-api::test ${p}
done

# these tests fail
rm -r jersey-json/src/test/java/com/sun/jersey/json/impl/NamespaceElementTest.java \
 jersey-json/src/test/java/com/sun/jersey/json/impl/NamespaceSupportIssue272Test.java \
 jersey-json/src/test/java/com/sun/jersey/json/impl/NamespaceAttributeTest.java

sed -i "s|<finalName>jersey-test-framework</finalName>||" \
jersey-test-framework/jersey-test-framework-core/pom.xml

rm -r jersey-server/src/test/java/com/sun/jersey/server/impl/BuildIdTest.java
# Cannot run program "svn"
%pom_remove_plugin org.codehaus.mojo:buildnumber-maven-plugin

%pom_xpath_remove "pom:profiles" contribs/wadl-resourcedoc-doclet
%pom_add_dep com.sun:tools contribs/wadl-resourcedoc-doclet
%pom_add_dep com.sun.jersey:jersey-server:'${project.version}' contribs/wadl-resourcedoc-doclet

%pom_remove_dep javax.el:el-api jersey-server-linking
%pom_add_dep org.jboss.spec.javax.el:jboss-el-api_2.2_spec jersey-server-linking
rm -r jersey-server-linking/src/test/java/com/sun/jersey/server/linking/el/LinkELContextTest.java
# IllegalStateException: Unsupported cookie spec: default
rm -r contribs/jersey-apache-client4/src/test/java/com

# Do not install source jars
#%%mvn_package ":::?*:" __noinstall
# Fix conflict with jersey-test-framework-core thanks to Mikolaj Izdebski
%mvn_file :%{name}-test-framework %{name}/%{name}-test-framework-pom
%mvn_file :%{name}-test-framework-core %{name}/%{name}-test-framework
%mvn_file :%{name}-test-framework-core %{name}/%{name}-test-framework-core
%mvn_package ":%{name}-test-framework" test-framework
%mvn_package ":%{name}-test-framework-core" test-framework 
%mvn_package ":%{name}-test-framework-external" test-framework
%mvn_package ":%{name}-test-framework-grizzly2" test-framework
%mvn_package ":%{name}-test-framework-http" test-framework
%mvn_package ":%{name}-test-framework-inmemory" test-framework
# contribs   %%{name}-simple-server
%mvn_package ":%{name}-contribs" contribs
%mvn_package ":ant-wadl-task" contribs
%mvn_package ":%{name}-apache-client" contribs
%mvn_package ":%{name}-apache-client4" contribs
%mvn_package ":%{name}-freemarker" contribs
%mvn_package ":%{name}-guice" contribs
%mvn_package ":%{name}-moxy" contribs
%mvn_package ":%{name}-multipart" contribs
%mvn_package ":%{name}-oauth" contribs
%mvn_package ":%{name}-spring" contribs
%mvn_package ":%{name}-wadl-json-schema" contribs
%mvn_package ":oauth-client" contribs
%mvn_package ":oauth-server" contribs
%mvn_package ":oauth-signature" contribs
%mvn_package ":wadl-resourcedoc-doclet" contribs
%mvn_package ":wadl-maven-plugin" maven-wadl-plugin

%build

%mvn_build

%install
%mvn_install

mkdir -p %{buildroot}%{_sysconfdir}/ant.d
echo "ant %{name}/%{name}-server jaxb-api" > ant-wadl-task
install -p -m 644 ant-wadl-task %{buildroot}%{_sysconfdir}/ant.d/ant-wadl-task

%files -f .mfiles
%dir %{_javadir}/%{name}
%doc dependencies.html getting-started.html 
%license license.html legal/LICENSE.txt legal/maintenance/copyright.txt LICENSE-2.0.txt

%files test-framework -f .mfiles-test-framework
%license license.html legal/LICENSE.txt legal/maintenance/copyright.txt

%files contribs -f .mfiles-contribs
%config(noreplace) %{_sysconfdir}/ant.d/ant-wadl-task
%license license.html legal/LICENSE.txt legal/maintenance/copyright.txt

%files -n maven-wadl-plugin -f .mfiles-maven-wadl-plugin
%license license.html legal/LICENSE.txt legal/maintenance/copyright.txt

%files javadoc -f .mfiles-javadoc
%license license.html legal/LICENSE.txt legal/maintenance/copyright.txt LICENSE-2.0.txt

%changelog
* Tue Jan 27 2015 gil cattaneo <puntogil@libero.it> 1.18.3-1
- update to 1.18.3
- introduce license macro

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.17.1-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Jun 05 2014 gil cattaneo <puntogil@libero.it> 1.17.1-10
- fix javax.el apis

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 1.17.1-9
- Use Requires: java-headless rebuild (#1067528)

* Mon Nov 18 2013 gil cattaneo <puntogil@libero.it> 1.17.1-8
- use objectweb-asm3

* Tue Oct 15 2013 gil cattaneo <puntogil@libero.it> 1.17.1-7
- Do not install source jars

* Tue Oct 15 2013 gil cattaneo <puntogil@libero.it> 1.17.1-6
- fix for rhbz#1019234

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.17.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jul 10 2013 gil cattaneo <puntogil@libero.it> 1.17.1-4
- switch to XMvn
- minor changes to adapt to current guideline
- fix aId for new istack-commons maven plugin

* Sat Apr 27 2013 gil cattaneo <puntogil@libero.it> 1.17.1-3
- rebuilt with grizzly support

* Thu Mar 28 2013 gil cattaneo <puntogil@libero.it> 1.17.1-2
- fixed license field
- installed ASL license txt file

* Mon Mar 18 2013 gil cattaneo <puntogil@libero.it> 1.17.1-1
- update to 1.17.1

* Tue Jan 22 2013 gil cattaneo <puntogil@libero.it> 1.17-1
- update to 1.17

* Fri Jan 11 2013 gil cattaneo <puntogil@libero.it> 1.16-1
- update to 1.16

* Mon Nov 19 2012 gil cattaneo <puntogil@libero.it> 1.15-1
- update to 1.15

* Tue Sep 18 2012 gil cattaneo <puntogil@libero.it> 1.14-1
- update to 1.14

* Sat Jul 21 2012 gil cattaneo <puntogil@libero.it> 1.13-1
- update to 1.13

* Fri May 25 2012 gil cattaneo <puntogil@libero.it> 1.12-1
- initial rpm
